/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.VirtualFileSystem.common;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.zip.ZipOutputStream;

import org.apache.log4j.Logger;

import com.sos.JSHelper.Basics.JSToolBox;
import com.sos.JSHelper.Exceptions.JobSchedulerException;
import com.sos.VirtualFileSystem.Interfaces.ISOSVfsFileTransfer;
import com.sos.VirtualFileSystem.Interfaces.ISOSVirtualFile;
import com.sos.i18n.annotation.I18NResourceBundle;

/**
* \class SOSVfsCommonFile 
* 
* \brief SOSVfsCommonFile - 
* 
* \details
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author KB
* \version $Id: SOSVfsCommonFile.java 16212 2012-01-13 14:42:13Z kb $ 29.03.2011
* \see reference
*
* Created on 29.03.2011 18:08:16
 */
/**
 * @author KB
 *
 */
@I18NResourceBundle(baseName = "SOSVirtualFileSystem", defaultLocale = "en")
public abstract class SOSVfsCommonFile extends JSToolBox implements ISOSVirtualFile {
	@SuppressWarnings("unused")
	private final String			conClassName			= "SOSVfsCommonFile";
	private static final Logger		logger					= Logger.getLogger(SOSVfsCommonFile.class);
	protected ISOSVfsFileTransfer	objVFSHandler			= null;
	protected InputStream			objInputStream			= null;
	public OutputStream				objOutputStream			= null;
	public ZipOutputStream			objEntryOutputStream	= null;

	public SOSVfsCommonFile() {
		//
	}

	public SOSVfsCommonFile(String pstrBundleBaseName) {
		super(pstrBundleBaseName);
	}

	/**
	 * \brief getHandler
	 * 
	 * \details
	 *
	 * \return 
	 *
	 * @return
	 */
	@Override
	public ISOSVfsFileTransfer getHandler() {
		return this.objVFSHandler;
	}

	@Override
	public String File2String() {
		InputStream objFI = this.getFileInputStream();
		if (objFI == null) {
			throw new JobSchedulerException("can't get InputStream");
		}
		StringBuffer strB = new StringBuffer((int) this.getFileSize());
		int lngBufferSize = 1024;
		byte[] buffer = new byte[lngBufferSize];
		int intBytesTransferred;
		try {
			while ((intBytesTransferred = objFI.read(buffer)) != -1) {
				strB.append(new String(buffer).substring(0, intBytesTransferred));
			}
			objFI.close();
		}
		catch (Exception e) {
			throw new JobSchedulerException("File2String failed", e);
		}
		return strB.toString();
	}

	@Override
	public void String2File(String pstrContent) {
		try {
			OutputStream objOS = this.getFileOutputStream();
			objOS.write(pstrContent.getBytes());
			objOS.close();
		}
		catch (IOException e) {
			throw new JobSchedulerException("String2File end with exception", e);
		}
	}

	@Override
	public void putFile(File fleFile) throws Exception {
		// TODO Auto-generated method stub
	}

	@Override
	public void putFile(String strFileName) throws Exception {
		// TODO Auto-generated method stub
	}

	@Override
	public long getFileSize() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public Integer getFilePermissions() throws Exception {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getModificationTime() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setFilePermissions(Integer pintNewPermission) throws Exception {
		// TODO Auto-generated method stub
	}

	@Override
	public boolean FileExists() throws Exception {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isDirectory() throws Exception {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean notExists() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isEmptyFile() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public OutputStream getFileOutputStream() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public OutputStream getFileAppendStream() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public InputStream getFileInputStream() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean delete() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void rename(String pstrNewFileName) {
		// TODO Auto-generated method stub
	}

	@Override
	public String getParentVfs() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ISOSVirtualFile getParentVfsFile() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setHandler(ISOSVfsFileTransfer pobjVFSHandler) {
		// TODO Auto-generated method stub
	}

	@Override
	public String getName() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String MakeZIPFile(String pstrZipFileNameExtension) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void write(byte[] bteBuffer, int intOffset, int intLength) {
		// TODO Auto-generated method stub
	}

	@Override
	public void write(byte[] bteBuffer) {
		// TODO Auto-generated method stub
	}

	@Override
	public int read(byte[] bteBuffer) {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public int read(byte[] bteBuffer, int intOffset, int intLength) {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public void close() {
		// TODO Auto-generated method stub
	}

	@Override
	public void flush() {
		// TODO Auto-generated method stub
	}

	@Override
	public void closeInput() {
		// TODO Auto-generated method stub
	}

	@Override
	public void closeOutput() {
		// TODO Auto-generated method stub
	}

	/**
	 * \brief deleteFile
	 * 
	 * \details
	 *
	 * \return 
	 *
	 * @throws Exception
	 */
	@Override
	public void deleteFile() {
		this.delete();
	}

	/**
	 * \brief getFile
	 * 
	 * \details
	 *
	 * \return 
	 *
	 * @return
	 * @throws Exception
	 */
	@Override
	public ISOSVirtualFile getFile() {
		return this;
	}
	

}
